import bcrypt from 'bcryptjs'
import crypto from 'crypto' 

export function createPasswordHash(password) { 
    const salt = bcrypt.genSaltSync(10)
    const hash = bcrypt.hashSync(password, salt)
    return hash
}

export function validatePassword(password, hash) { 
    const res = bcrypt.compareSync(password, hash)
    return res
}

export function makeSessionId() {
    return crypto.randomBytes(24).toString('hex') 
}

export function setCookieHttpResponse(token) { 
    const date = () => {
        const now = new Date()
        const date = new Date(now.setDate(now.getDate() + 5))
        return date
    }

    return {
        statusCode: 200,
        headers: {
            'Set-Cookie': `session=${
               token
            }; Expires=${date()};path=/; SameSite=Strict; Secure; HttpOnly;`
        },
        body: JSON.stringify({
            status: 'success'
        })
    }
}

export function getSessionCookieFromtApiEvent(event) { 
    const headers = event.headers
    const cookie =
        headers.cookie && headers.cookie.startsWith('session=')
            ? headers.cookie.split('=')[1]
            : 'no session found'

    if (cookie === 'no session found') {
        return false
    }
    return jwt
}
